
      PROGRAM MIE                                                        
                                                                        
                                                                        
!       Ohjelma MIE laskee sirontaongelman pallon tapauksessa.          
                                                                        
                                                                        
                                ! Tyyppimaarittelyt.                    
      IMPLICIT none                                                      
      CHARACTER i                                                        
      INTEGER j                                                          
      REAL refmed, refre, refim, sizeparameter, pi, qext,    &
      qsca, qback, size, theta (0:180), s11 (181), s12 (181), s33 (181),&
      s34 (181)                                                         
      complex refrel, s1 (200), s2 (200)                           
      COMMON pi                                                          
                                                                        
      WRITE (*,*) ' Mie scattering program'                         
                                                                        
!        read (5,20) radius,lwave,refre,refim                           
! 20           format (4E12.6)                                          
!       read (5,20) sizeparameter,refre,refim                           
      WRITE ( * , * ) 'sizeparameter,refre,refim'                        
      READ ( *, * ) sizeparameter, refre, refim                          
      WRITE ( *, * ) sizeparameter, refre, refim                         
!   20 FORMAT         (3E12.6)                                            
                                                                        
      pi = 3.1415926535898                                               
      refmed = 1.0                                                       
      refrel = cmplx (refre, refim) / refmed                            
!      sizeparameter=2.0*pi/lwave*radius                                
      size = sizeparameter * (4. * pi / 3.) ** (1. / 3.)                 
                                                                        
                                                                        
                                                ! Parametrien tulostusta
      WRITE (6, *) refmed, refre, refim                                 
!      write (6,70) radius,lwave                                        
      WRITE (6, 80) sizeparameter                                        
!   60 FORMAT (//5X, 'Refmed = ', F4.2, 7X, 'Refre = ', E10.4, 5X, 'Refim&
!     & = '                                                              
! 70           format (5X,'Sphere radius = ',F7.3,3X,'Wavelength = ',F7.
   80 FORMAT             (5X,'Size parameter = ',F8.3/)                  
                                                                        
                                                                        
      CALL BHMIE (sizeparameter, refrel, 91, s1, s2, qext, qsca, qback)  
                                                                        
                                                                        
                                                ! Parametrien tulostusta
      WRITE (6, 90) qsca, qext, qback                                    
      WRITE (6, 100)                                                     
   90 FORMAT     (//,1X,'qsca= ',E13.6,3X,'qext= ',E13.6,3X,            &
     &  'qback= ',E13.6)                                                
  100 FORMAT        (//3X,'deg',8X,'s11',13X,'s12',13X,'s33',13X,'s34'/) 
                                                                        
                                                                        
                                                        ! Matriisielemen
      DO 110 j = 1, 181,10                                                  
                                                        ! numeerinen tul
         s11 (j) = 0.5 * (abs (s1 (j) ) **2 + abs (s2 (j) ) **2)     
                                                        ! tus.          
         s12 (j) = - 0.5 * (abs (s1 (j) ) **2 - abs (s2 (j) ) **2)   
         s33 (j) = real (s2 (j) * conjg (s1 (j) ) )                    
         s34 (j) = aimag (s2 (j) * conjg (s1 (j) ) )                    
         theta (j - 1) = j - 1.0                                    
         WRITE (6, 200) theta (j - 1), s11 (j), s12 (j), s33 (j),       &
         s34 (j)                                                        
  110 END DO                                                             
                                                                        
                                                                        
                                                       ! Muotoiluohjeet.
  200 FORMAT        (3X,F4.0,4(3X,E13.6))                                
  210 FORMAT           (F12.6)                                           
  215 FORMAT              (E12.6)                                        
  220 FORMAT                 (6E10.5)                                    
      END PROGRAM MIE                               
                                                                        
                                                                        
!       Aliohjelmat:                                                    
                                                                        
                                                                        
!       BHMIE laskee amplitudisirontamatriisielementit ja tehol-        
!     liset vaikutusalat.                                               
                                                                        
                                                                        
      SUBROUTINE BHMIE (sizeparameter, refrel, nang, s1, s2, qext, qsca,&
      qback)                                                            
      IMPLICIT none                                                      
      INTEGER nstop, nmx, j, nn, n, nang, jj                             
      REAL amu (100), theta (100), pi (100), tau (100),      &
      pi0 (100), pi1(100), xstop, ymod, dang, rn, apsi0, apsi1, fn, chi,     &
      chi0, chi1, p, t, apsi, pii, psi0, psi1, psi, sizeparameter, qext, &
      qsca, qback                                                       
      complex d (3000), y, refrel, xi, xi0, xi1, an, bn, s1 (200),&
      s2 (200)                                                          
      COMMON pii                                                         
                                                                        
      y = sizeparameter * refrel                                         
                                                           ! Sarja katka
      xstop = sizeparameter + 4.0 * sizeparameter**.3333 + 2.0           
                                                           ! paikasta ns
      nstop = int (xstop)                                              
      ymod = abs (y)                                                   
      nmx = max (xstop, ymod) + 15                                     
      dang = pii / 2. / (nang - 1.0)                                  
                                                                        
      DO 300 j = 1, nang                                                 
         theta (j) =  (j - 1.0) * dang                                 
         amu (j) = cos (theta (j) )                                     
  300 END DO                                                             
                                                                        
                                                                        
                                ! Logaritmiset derivaatat lasketaan     
      d (nmx) = cmplx (0.0, 0.0)                                        
                                ! kaanteiselle rekursiolla alkaen       
      nn = nmx - 1                                                       
                                ! termista nmx.                         
      DO 310 n = 1, nn                                                   
         rn = (nmx - n + 1.0)                                         
         d (nmx - n) = (rn / y) - (1. / (d (nmx - n + 1) + rn / y) )     
  310 END DO                                                             
                                                                        
      DO 320 j = 1, nang                                                 
         pi0 (j) = 0.0                                                   
         pi1 (j) = 1.0                                                   
  320 END DO                                                             
                                                                        
      nn = 2 * nang - 1                                                  
                                                                        
      DO 330 j = 1, nn                                                   
         s1 (j) = cmplx (0.0, 0.0)                                      
         s2 (j) = cmplx (0.0, 0.0)                                      
  330 END DO                                                             
                                                                        
                                                                        
                                 ! Reaaliargumenttiset Riccati-Bessel -f
      psi0 = cos (sizeparameter)                                        
                                 ! maarataan normaalirekursiolla.       
      psi1 = sin (sizeparameter)                                        
      chi0 = - sin (sizeparameter)                                      
      chi1 = cos (sizeparameter)                                        
      apsi0 = psi0                                                       
      apsi1 = psi1                                                       
      xi0 = cmplx (apsi0, - chi0)                                       
      xi1 = cmplx (apsi1, - chi1)                                       
      qsca = 0.0                                                         
      n = 1                                                              
                                                                        
  340 rn = real (n)                                                      
      fn = (2.0 * rn + 1.0) / (rn * (rn + 1.0) )                         
      psi = (2.0 * rn - 1.0) * psi1 / sizeparameter - psi0               
      apsi = psi                                                         
      chi = (2.0 * rn - 1.0) * chi1 / sizeparameter - chi0               
      xi = cmplx (apsi, - chi)                                          
      an = (d (n) / refrel + rn / sizeparameter) * apsi - apsi1          
      an = an / ( (d (n) / refrel + rn / sizeparameter) * xi - xi1)      
      bn = (refrel * d (n) + rn / sizeparameter) * apsi - apsi1          
      bn = bn / ( (refrel * d (n) + rn / sizeparameter) * xi - xi1)      
      qsca = qsca + (2.0 * rn + 1.0) * (abs (an) **2 + abs (bn) **2) 
                                                                        
      DO 350 j = 1, nang                                                 
         jj = 2 * nang - j                                               
         pi (j) = pi1 (j)                                                
         tau (j) = rn * amu (j) * pi (j) - (rn + 1.0) * pi0 (j)          
         p = ( - 1.0) ** (n - 1)                                         
         s1 (j) = s1 (j) + fn * (an * pi (j) + bn * tau (j) )            
         t = ( - 1.0) **n                                                
         s2 (j) = s2 (j) + fn * (an * tau (j) + bn * pi (j) )            
         IF (j.eq.jj) goto 350                                           
         s1 (jj) = s1 (jj) + fn * (an * pi (j) * p + bn * tau (j)       &
         * t)                                                           
         s2 (jj) = s2 (jj) + fn * (an * tau (j) * t + bn * pi (j)       &
         * p)                                                           
  350 END DO                                                             
                                                                        
      psi0 = psi1                                                        
      psi1 = psi                                                         
      apsi1 = psi1                                                       
      chi0 = chi1                                                        
      chi1 = chi                                                         
      xi1 = cmplx (apsi1, - chi1)                                       
      n = n + 1                                                          
      rn = real (n)                                                      
                                                                        
      DO 360 j = 1, nang                                                 
         pi1 (j) = ( (2.0 * rn - 1.0) / (rn - 1.0) ) * amu (j) * pi (j)  
         pi1 (j) = pi1 (j) - rn * pi0 (j) / (rn - 1.0)                   
         pi0 (j) = pi (j)                                                
  360 END DO                                                             
                                                                        
      IF (n - 1 - nstop) 340, 370, 370                                   
                                                                        
  370 qsca = (2.0 / (sizeparameter**2) ) * qsca                          
      qext = (4.0 / (sizeparameter**2) ) * real (s1 (1) )               
      qback = (4.0 / (sizeparameter**2) ) * abs (s1 (2 * nang - 1) )  &
      **2                                                               
      END SUBROUTINE BHMIE                          




