	MODULE Mie
	USE Constants
	IMPLICIT NONE
	REAL*8 CextMie,CscaMie,s11Mie(80),s12Mie(80)
	REAL*8 CextMie1,CscaMie1,s11Mie1(80),s12Mie1(80)


       CONTAINS  

!       BHMIE laskee sirontamatriisielementit ja tehol-        
!     liset vaikutusalat.


      SUBROUTINE BHMIE (sizeparameter,refrel,nang,s11,s12,qext,qsca)
      REAL*8,INTENT(in)::sizeparameter 
      COMPLEX*16,INTENT(in)::refrel
      INTEGER,intent(in)::nang
      REAL*8, INTENT(out),DIMENSION(nang)::s11,s12
      REAL*8, INTENT(out):: qext,qsca

      INTEGER nstop, nmx, j, nn, n
      REAL*8,dimension(nang):: amu, theta, pii,tau,pi0, pi1
      REAL*8 xstop, ymod, dang, rn, apsi0, apsi1, fn, chi,
     &         chi0, chi1, apsi, psi0, psi1, psi, xxx
      complex*16  y, xi, xi0, xi1, an, bn 
      complex*16,dimension(nang):: d (3000), s1,s2 

      y = sizeparameter * refrel 
      xxx=sizeparameter*max(abs(refrel),DBLE(1.0))
                                                           ! Sarja katka
!      xstop = sizeparameter + DBLE(4.0) * sizeparameter**DBLE(.3333) + DBLE(2.0) 
      xstop = xxx + DBLE(4.0) *xxx**DBLE(.3333) + DBLE(3.0) 
                                                           ! paikasta ns
      nstop = int(xstop)
      ymod = abs(y)
      nmx = max (xstop, ymod) + 15 
      dang = pi  / (nang - DBLE(1.0))

      DO  j = 1, nang 
         theta(j) =  (j - DBLE(1.0)) * dang  
         amu(j) = cos(theta(j)) 
      END DO 
      d (nmx) = dcmplx (0.0, 0.0) 
      nn = nmx - 1 
      DO n = 1, nn
         rn = (nmx - n + DBLE(1.0))  
         d(nmx - n)=(rn / y)-(DBLE(1.0)/(d(nmx-n+1)+rn/y))     
      END DO 
 
      pi0 (:) = DBLE(0.0)
      pi1 (:) = DBLE(1.0) 

      nn = 2 * nang - 1 

      s1 (:) =z0! cmplx (0.0, 0.0) 
      s2 (:) =z0! cmplx (0.0, 0.0) 
                                 ! Reaaliargumenttiset Riccati-Bessel -f
      psi0 = cos(sizeparameter) 
                                 ! maarataan normaalirekursiolla. 
      psi1 = sin(sizeparameter) 
      chi0 = -sin(sizeparameter) 
      chi1 = cos(sizeparameter) 
      apsi0 = psi0 
      apsi1 = psi1
      xi0 = cmplx(apsi0, - chi0)
      xi1 = cmplx(apsi1, - chi1) 
      qsca = DBLE(0.0)
      n = 1 
      recursion: DO
      rn=DBLE(n)
      fn=(DBLE(2.0) *rn + DBLE(1.0)) / (rn * (rn + DBLE(1.0)) ) 
      psi=(DBLE(2.0)*rn - DBLE(1.0))*psi1/sizeparameter - psi0 
      apsi= psi 
      chi=(DBLE(2.0)*rn-DBLE(1.0))*chi1/sizeparameter - chi0
      xi=cmplx (apsi, - chi)
      an=(d (n) / refrel+rn / sizeparameter) * apsi - apsi1
      an=an / ( (d(n)/refrel + rn / sizeparameter) * xi - xi1) 
      bn=(refrel * d(n) + rn / sizeparameter) * apsi - apsi1
      bn=bn / ( (refrel*d(n)+rn/sizeparameter) * xi - xi1)      
      qsca=qsca+(DBLE(2.0)*rn+DBLE(1.0))*(abs(an)**2+abs(bn)**2) 

      pii(:)=pi1(:)
      tau(:)=rn * amu(:) * pii(:) - (rn + DBLE(1.0)) * pi0(:)
      s1(:)=s1(:) + fn * (an * pii(:) + bn * tau(:) ) 
      s2(:)=s2(:) + fn * (an * tau(:) + bn * pii(:) )            
      psi0=psi1 
      psi1=psi 
      apsi1=psi1
      chi0=chi1 
      chi1 = chi  
      xi1 = cmplx(apsi1, - chi1)
      n = n + 1 
      rn = DBLE(n) 

      DO j = 1, nang 
         pi1(j)=((DBLE(2.0)*rn-DBLE(1.0))/(rn-DBLE(1.0)))*amu(j)*pii(j) 
         pi1(j) = pi1(j) - rn * pi0(j) / (rn - DBLE(1.0)) 
         pi0(j) = pii(j) 
      END DO 

      IF ((n - 1 - nstop)>=0) EXIT  recursion
      ENDDO recursion   

!      print*,'Mie2',qsca,twopi 
!  qsca=2/x**2 q'
!  c=pi*a**2*qsca=2pi(a/x)**2 q'    (x=ka=2pia/lambda, lambda==1)

      qsca = (DBLE(2.0) / (sizeparameter**2) ) * qsca                          
      qext = (DBLE(4.0) / (sizeparameter**2) ) * dreal (s1 (1))               

! 1/(kr)**2 S=C/r**2 P/4 pi, P=4pi S/C 4 pi**2=S/Cpi

         s11 (:) =   DBLE(0.5) * (abs(s1(:))**2 + abs(s2(:))**2)  
         s12 (:) = - DBLE(0.5) * (abs(s1(:))**2 - abs(s2(:))**2)  
!         s33 (j) = real (s2 (j) * conjg (s1 (j) ) )                    
!         s34 (j) = aimag (s2 (j) * conjg (s1 (j) ) )                    

      END SUBROUTINE BHMIE 

      END MODULE MIE
