      MODULE Nonag
! This module contains just cheap replacements for some NAG routines.
! They are not necessarily even near as fast, reliable, accurate and 
! general as their NAG counterparts.
! Use of real NAG-library is always recommended prior to this module.
! Do not use these routines for any other purposese. They most
! probably do not work.



      CONTAINS
!
!********************************************************************
!
	SUBROUTINE  S17DEF(half,x,maxii,nothing,Bessel,nzero,ifail) 
!
! Cylindrical Bessel: J_(i+0.5)(x), i=0 ...maxi 

	USE Constants
	IMPLICIT NONE

	CHARACTER,INTENT(in)::nothing
	INTEGER,INTENT(in)::maxii
	REAL*8,INTENT(in)::half
	COMPLEX*16,INTENT(in)::x
	COMPLEX*16,DIMENSION(0:maxii-1),INTENT(out):: Bessel
!
	INTEGER i,nzero,ifail,maxi
	REAL *8 fr2
	COMPLEX*16 ix,sx,cx,xx(0:maxii+8)

	IF (abs(half-DBLE(0.5))>11*Epsilon(half))
     &       write(*,*)'Bessel tokkii'
!
	maxi=maxii-1
	Bessel=Huge(DBLE(1.0))
!       write(*,*)'BESSELS',x,maxi
!
	IF (REAL(x)<DBLE(0.0))
     &     STOP 'Bessels with negative argument 
     &            should not appear in this code'
!
        IF (abs(x) < DBLE(0.5)) THEN  ! series, see A&S Eq:10.1.2
	  xx(0)=DBLE(1.0)
          DO i=1,max(8,maxi+4);xx(i)=xx(i-1)*x;ENDDO
	    Bessel(0)=DBLE(1.0)-xx(2)/DBLE(6.0)+xx(4)/(DBLE(2.0)*3*4*5)-
     &       xx(6)/(2.0**3*2*3*3*5*7.0)+xx(8)/(2.0**4*2*3*4*3*5*7*9.0)
	    IF (maxi>=1) THEN                              
	     Bessel(1)=x/DBLE(3.0)*(DBLE(1.0)-xx(2)/DBLE(10.0)+
     &         xx(4)/(DBLE(2.0)*4*5*7)-xx(6)/(2.0**3*2*3*5*7*9.0))
	     IF (maxi>=2) THEN
	       Bessel(2)=xx(2)/DBLE(15.0)*(DBLE(1.0)-xx(2)/DBLE(14.0)+
     &         xx(4)/(DBLE(2.0)*4*7*9)-xx(6)/(2.0*8*7*9*11.0))
	       fr2=DBLE(1.0)*DBLE(3.0)*DBLE(5.0)
!
	       DO i=3,maxi
		 fr2=fr2*(DBLE(2.0)*i+DBLE(1.0))
		 Bessel(i)=xx(i)/fr2*(DBLE(1.0)-xx(2)/(4*i+DBLE(6.0))+
     &           xx(4)/(2.0*4*(2*i+3.0)*(2*i+5.0))) 
	       ENDDO
!
	     ENDIF
	    ENDIF
	  ELSE
            ix=DBLE(1.0)/x;sx=sin(x);cx=cos(x)
	    Bessel(0)=sx*ix
	    IF (maxi>=1) THEN
	      Bessel(1)=(sx*ix-cx)*ix

	      IF (maxi>=2) THEN
	        Bessel(2)=(DBLE(3.0)*ix**2-DBLE(1.0))*sx*ix
     &                -DBLE(3.0)*cx*ix**2

	        DO i=3,maxi 
! Warning: very instabil recursion ! Not good for high i's!!
! As said, this is only an emergency solution for those without NAG-library.
! A good library bessel is strongly recommended.
		Bessel(i)=(2*i-1)*Bessel(i-1)*ix-Bessel(i-2)
	       ENDDO
	      ENDIF
	     ENDIF 
!
	   ENDIF
	   Bessel=sqrt(x/(DBLE(0.5)*pi))*Bessel
! write(*,*)bessel

	END SUBROUTINE S17DEF

        END MODULE Nonag


