      MODULE Vectorix
! to define some types, constants and subroutines
! especially various matrix and vector operations


      USE Constants
      IMPLICIT NONE



      COMPLEX*8,DIMENSION(3),PARAMETER::uv_zero=(/z0,z0,z1/),  
     &            uv_minus=(/z1*0.707106781188,-im*0.707106781188,z0/),
     &            uv_plus=(/-z1*0.707106781188,-im*0.707106781188,z0/),
     &            uv_1=(/z1,z0,z0/),uv_2=(/z0,z1,z0/),
     &            uv_3=uv_zero,c000=(/z0,z0,z0/)

      REAL*4,DIMENSION(3),PARAMETER::unitx=(/1.0,0.0,0.0/), 
     &                   unity=(/0.0,1.0,0.0/),unitz=(/0.0,0.0,1.0/), 
     &                   r000=(/0.0,0.0,0.0/)



      INTERFACE OPERATOR(.Cross.)
        MODULE PROCEDURE Cross_prod2c,Cross_prod2r
      END INTERFACE


      CONTAINS


      FUNCTION Cross_prod2c(u,v)
      COMPLEX*8,DIMENSION(3),intent(in)::u,v
      COMPLEX*8,DIMENSION(3):: Cross_prod2c
       Cross_prod2c(1)=u(2)*v(3)-u(3)*v(2)
       Cross_prod2c(2)=u(3)*v(1)-u(1)*v(3)
       Cross_prod2c(3)=u(1)*v(2)-u(2)*v(1)
      END FUNCTION Cross_prod2c

      FUNCTION Cross_prod2r(u,v)
      REAL*4,DIMENSION(3),intent(in)::u,v
      REAL*4,DIMENSION(3):: Cross_prod2r
       Cross_prod2r(1)=u(2)*v(3)-u(3)*v(2)
       Cross_prod2r(2)=u(3)*v(1)-u(1)*v(3)
       Cross_prod2r(3)=u(1)*v(2)-u(2)*v(1)
      END FUNCTION Cross_prod2r

      FUNCTION Normalize(v)
      REAL*4,DIMENSION(3):: Normalize
      REAL*4,DIMENSION(3),intent(in)::v
      Normalize=v/sqrt(dot_product(v,v))
      END FUNCTION Normalize

      FUNCTION Normalizec(v)
      COMPLEX*8,DIMENSION(3):: Normalizec
      COMPLEX*8,DIMENSION(3),intent(in)::v
      Normalizec=v/sqrt(dot_product(v,v))
      END FUNCTION Normalizec



      END MODULE Vectorix

